"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var foundation_settings_1 = require("@uifabricshared/foundation-settings");
var Token_1 = require("./Token");
var Token_function_1 = require("./Token.function");
function stockFakeComponent(props, _settings, _theme, _cache, _recurse) {
    return props;
}
exports.stockFakeComponent = stockFakeComponent;
function mockCreate(options) {
    var slots = options.slots;
    var hasTokens = slots
        ? function (target, key) {
            var targetOptions = slots[target] && slots[target].component && slots[target].component.__options;
            return targetOptions && targetOptions.tokenKeys.hasOwnProperty(key);
        }
        : undefined;
    var resolvedTokens = Token_function_1.buildComponentTokens(slots, hasTokens);
    var fn = function (props, settings, theme, cache, recurse) {
        var newSettings = Token_1.processTokens(props, theme, settings, resolvedTokens, 'base', cache);
        if (recurse) {
            Object.keys(slots).forEach(function (slotName) {
                var _a;
                var slot = slots[slotName];
                if (slot.component.__options && newSettings[slotName]) {
                    cache[slotName] = cache[slotName] || {};
                    var slotSettings = slot.component(newSettings[slotName] || {}, {}, theme, cache[slotName], false);
                    var rootKey = 'root';
                    if (slotSettings[rootKey]) {
                        newSettings = foundation_settings_1.mergeSettings(newSettings, (_a = {}, _a[slotName] = slotSettings[rootKey], _a));
                    }
                }
            });
        }
        return newSettings;
    };
    fn.__options = resolvedTokens;
    return fn;
}
exports.mockCreate = mockCreate;
//# sourceMappingURL=MockComponent.js.map