/// <reference types="react" />
import { IMockTheme } from './MockTheme';
import { IComponentTokens, ISlotStyleFactories } from './Token.types';
import { IStyleProp, IComponentSettings } from '@uifabricshared/foundation-settings';
export declare type ICSSStyle = React.CSSProperties;
export interface IMockBaseProps {
    style?: IStyleProp<ICSSStyle>;
}
export declare type IMockComponentFn<TProps, TSlotProps> = (props: TProps, settings: TSlotProps, theme: IMockTheme, cache: object, recurse?: boolean) => TSlotProps | TProps;
export declare type IMockComponent<TProps, TSlotProps> = IMockComponentFn<TProps, TSlotProps> & {
    __options?: IComponentTokens<TProps, IMockTheme>;
};
export declare type IMockSlots<TProps> = {
    root: {
        component: IMockComponent<TProps, IComponentSettings>;
    } & ISlotStyleFactories<TProps, IMockTheme>;
    [key: string]: {
        component: IMockComponent<TProps, IComponentSettings>;
    } & ISlotStyleFactories<TProps, IMockTheme>;
};
export interface IMockComponentOptions<TProps> {
    slots?: IMockSlots<TProps>;
}
export declare function stockFakeComponent(props: IMockBaseProps, _settings: IComponentSettings, _theme: IMockTheme, _cache: object, _recurse: boolean): IMockBaseProps;
export declare function mockCreate<TProps extends object, TSettings extends IComponentSettings>(options: IMockComponentOptions<TProps>): IMockComponent<TProps, TSettings>;
//# sourceMappingURL=MockComponent.d.ts.map