import { mergeSettings } from '@uifabricshared/foundation-settings';
import { processTokens } from './Token';
import { buildComponentTokens } from './Token.function';
export function stockFakeComponent(props, _settings, _theme, _cache, _recurse) {
    return props;
}
export function mockCreate(options) {
    var slots = options.slots;
    var hasTokens = slots
        ? function (target, key) {
            var targetOptions = slots[target] && slots[target].component && slots[target].component.__options;
            return targetOptions && targetOptions.tokenKeys.hasOwnProperty(key);
        }
        : undefined;
    var resolvedTokens = buildComponentTokens(slots, hasTokens);
    var fn = function (props, settings, theme, cache, recurse) {
        var newSettings = processTokens(props, theme, settings, resolvedTokens, 'base', cache);
        if (recurse) {
            Object.keys(slots).forEach(function (slotName) {
                var _a;
                var slot = slots[slotName];
                if (slot.component.__options && newSettings[slotName]) {
                    cache[slotName] = cache[slotName] || {};
                    var slotSettings = slot.component(newSettings[slotName] || {}, {}, theme, cache[slotName], false);
                    var rootKey = 'root';
                    if (slotSettings[rootKey]) {
                        newSettings = mergeSettings(newSettings, (_a = {}, _a[slotName] = slotSettings[rootKey], _a));
                    }
                }
            });
        }
        return newSettings;
    };
    fn.__options = resolvedTokens;
    return fn;
}
//# sourceMappingURL=MockComponent.js.map